import System;
import System.Xml;

// Load the XML document
var xDoc:XmlDocument = new XmlDocument();
xDoc.Load("11-1.xml");

// Get the root element
var xRootNode:XmlNode = xDoc.DocumentElement;
var i:int;

if ( xRootNode.HasChildNodes ) {
    // This is a working usage.  So the important items are being parsed.
    Console.WriteLine("Internal Settings - ");
    for(i = 0; i < xRootNode.ChildNodes.Count; i++) {
        if ( xRootNode.ChildNodes[i].LocalName == "INTERNAL" ) {
            Console.WriteLine("\tName   : " + xRootNode.ChildNodes[i].Attributes["Type"].Value);
            Console.WriteLine("\tValue  : " + xRootNode.ChildNodes[i].InnerText);
            Console.WriteLine();
        }
    }
    
    Console.WriteLine("Line Objects - ");
    for(i = 0; i < xRootNode.ChildNodes.Count; i++) {
        if ( xRootNode.ChildNodes[i].LocalName == "LINE" ) {
            Console.WriteLine("\tLabel  : " + xRootNode.ChildNodes[i]["LABEL"].InnerText);
            Console.WriteLine("\tType   : " + xRootNode.ChildNodes[i]["TYPE"].InnerText);
            Console.WriteLine();
        }
    }
}