import System;
import System.Collections;

public class PropBrowser implements IEnumerable {
    public var Field1:int;
    public var Field2:int;
    public var Field3:int;
    
    public function PropBrowser() {
        this.Field1 = 1;
        this.Field2 = 10;
        this.Field3 = 100;
    }
    
    public override function GetEnumerator() : IEnumerator {
        return new PropBrowserEnumerator(this.Field1,this.Field2,this.Field3);
    }
    
    public class PropBrowserEnumerator implements IEnumerator {
        var _current:int;
        var Field1:int;
        var Field2:int;
        var Field3:int;
        
        public function PropBrowserEnumerator(field1:int,field2:int,field3:int) {
            this.Field1 = field1;
            this.Field2 = field2;
            this.Field3 = field3;
            _current = -1;
        }
        
        public function get Current() : Object {
            if ( _current == 3 || _current == -1 ) {
                throw new InvalidOperationException();
            } else {
                switch(_current) {
                    case 0:
                        return this.Field1;
                    case 1:
                        return this.Field2;
                    case 2:
                        return this.Field3;
                }
            }
        }
        
        public override function MoveNext() : Boolean {
            _current++;

            if ( _current == 3 ) {
                return false;
            } else {
                return true;
            }
        }
    
        public override function Reset() : void {
            _current = -1;
        }
    }
}

var p:PropBrowser = new PropBrowser();

for(var e:IEnumerator = p.GetEnumerator(); e.MoveNext();) {
    Console.WriteLine(e.Current);
}
