@cc_on
@set @position(file="Profiler.js";line=1;column=0)
import System;
import System.Collections;

class Profiler {
    private static var hsh:Hashtable;
    
    public static function CallFunction(name:String) : void {
        if (hsh == null) {
            hsh = new Hashtable();
        }
        
        if ( hsh[name] == null ) {
            hsh[name] = 1;
        } else {
            hsh[name]++;
        }
    }
    
    public static function PrintCallUsage() : void {
        var key:String;
        
        for(key in hsh.Keys) {
            Console.WriteLine("{0,-20} {1}", key, hsh[key]);
        }
    }
}
// CallFunction Injected Code Failure
// PrintCallUsage Injected Code Failure
@set @position(end)
import System;

class AlgorithmHolder {
    public static function Algorithm1() : void {
@set @position(file="Profiler.js";line=28;column=0)
        Profiler.CallFunction("Algorithm1");
@set @position(end)
         return;
    }
    public static function Algorithm2() : void {
@set @position(file="Profiler.js";line=28;column=0)
        Profiler.CallFunction("Algorithm2");
@set @position(end)
         return;
    }
}

var rand:Random = new Random();
var i:int = 0;

for(i = 0; i < 20; i++) {
    switch(rand.Next(0,2)) {
        case 0:
            AlgorithmHolder.Algorithm1();
            break;
        case 1:
            AlgorithmHolder.Algorithm2();
            break;
        default:
            // Never gets called
            AlgorithmHolder.Algorithm1();
            break;
    }
}

@set @position(file="Profiler.js";line=29;column=0)
    Profiler.PrintCallUsage();
@set @position(end)
