import System;
import System.Text.RegularExpressions;

var re:Regex = new Regex("(?<digits>\\d+) (?<word>[\\w\\.]+)");
var m:Match = re.Match("123 JScript.NET");

Console.WriteLine("Match Results:");
Console.WriteLine("Success: " + m.Success);
Console.WriteLine("Value: " + m.Value);
Console.WriteLine();

Console.WriteLine("Group Results:");
Console.WriteLine("Groups[0]: " + m.Groups[0].Value);
Console.WriteLine("Groups[1]: " + m.Groups[1].Value);
Console.WriteLine("Groups[2]: " + m.Groups[2].Value);
Console.WriteLine();
Console.WriteLine("Groups[\"digits\"]: " + m.Groups["digits"].Value);
Console.WriteLine("Groups[\"word\"]: " + m.Groups["word"].Value);

// Reordered
re = new Regex("(?<word>[\\w\\.]+) (?<digits>\\d+)");
m = re.Match("JScript.NET 123");

Console.WriteLine("Match Results:");
Console.WriteLine("Success: " + m.Success);
Console.WriteLine("Value: " + m.Value);
Console.WriteLine();

Console.WriteLine("Group Results:");
Console.WriteLine("Groups[0]: " + m.Groups[0].Value);
Console.WriteLine("Groups[1]: " + m.Groups[1].Value);
Console.WriteLine("Groups[2]: " + m.Groups[2].Value);
Console.WriteLine();
Console.WriteLine("Groups[\"digits\"]: " + m.Groups["digits"].Value);
Console.WriteLine("Groups[\"word\"]: " + m.Groups["word"].Value);